import fetch from 'isomorphic-fetch';

const opts = {
  beforeSend: (result) => {
  }
};

function myFetch(url, opt) {
  return new Promise(async (resolve, reject) => {
    try{
      const result = await fetch(url, opt);
      resolve(result);
    } catch (e) {
      reject(e);
    }
  });
}

async function $fetch(url, option = {}) {
  const result = myFetch(url, option);
  opts.beforeSend(result);
  return result;
}

async function $get(url) {
  const getOpts = Object.assign({
    method: 'GET'
  }, opts);
  const result = await myFetch(`${url}?t=${+new Date()}`, getOpts);
  opts.beforeSend(result);
  return result;
}

async function $post(url, data) {
  const postOpts = Object.assign({
    method: 'POST'
  }, opts);
  if (data) {
    postOpts.body = JSON.stringify(data);
  }
  const result = await myFetch(url, postOpts);
  opts.beforeSend(result);
  return result;
}

export default {
  fetch: $fetch,
  get: $get,
  post: $post,
  install: (Vue, options) => {
    Object.assign(opts, options);
    Vue.mixin({
      methods: {
        $fetch,
        $get,
        $post
      }
    });
  }
};
